package xtext.workshop.advanced.validation;

import org.eclipse.xtext.validation.Check;

import xtext.workshop.advanced.touristguideDsl.City;
import xtext.workshop.advanced.touristguideDsl.TouristguideDslPackage;

public class TouristguideDslJavaValidator extends
		AbstractTouristguideDslJavaValidator {

	public static final String INVALID_NAME = "xtext.workshop.advanced.quickfix.InvalidTypeName";

	@Check
	public void checkTypeNameStartsWithCapital(City city) {
		if (city.getName() == null || city.getName().length() == 0)
			return;
		if (!Character.isUpperCase(city.getName().charAt(0))) {
			warning("Name should start with a capital letter.",
					TouristguideDslPackage.CITY__NAME, INVALID_NAME,
					city.getName());

		}
	}

	public static final String CITY_NOT_INTERESTING = "xtext.workshop.advanced.quickfix.CityNotInteresting";

	@Check
	public void checkAtLeastOneSight(City city) {
		if (city.getSights().size() == 0) {
			warning("City not interesting - no sights specified.", city,
					TouristguideDslPackage.CITY__NAME, CITY_NOT_INTERESTING);
		}
	}
}
